Lua_ExchangeJewelWindow = class("Lua_ExchangeJewelWindow", Lua_Window);
function Lua_ExchangeJewelWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_ExchangeJewelWindow";
    self.skinName = "ExchangeJewelWindow_skin";
end
function Lua_ExchangeJewelWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.max_sell_num = DataCenter.moneyData.max_sell_num;
    self.exchange_power = DataCenter.moneyData.exchange_power;
    
    self.onSubBtn1:addClickFuntion(self, self.onSubBtnClick);
    self.onAddBtn1:addClickFuntion(self, self.onAddBtnClick);
    self.onAddTenBtn1:addClickFuntion(self, self.onAddTenBtnClick);
    self.onNumTxt1:addClickFuntion(self, self.onNumTxtChange);

    self.onSubBtn2:addClickFuntion(self, self.onGoldSubBtnClick);
    self.onAddBtn2:addClickFuntion(self, self.onGoldAddBtnClick);
    self.onAddTenBtn2:addClickFuntion(self, self.onGoldAddTenBtnClick);
    self.onNumTxt2:addClickFuntion(self, self.goldTxtChange);
    
    self.subBtn:addClickFuntion(self, self.onOnShelvesBtnClick);
    self:initItemInfo();
    
    self:addLuaEvent("MONEY_UPDATE", self, self.initItemInfo);
end


function Lua_ExchangeJewelWindow:initItemInfo()
    if self.exchange_power < 1 then
        self.exchange_power = 1;
    end
    if self.onNumTxt1 ~= nil then
        self.onNumTxt1.text = self.exchange_power;
    end
    if self.onNumTxt2 ~= nil then
        self.onNumTxt2.text = "1";
    end
    self.onNum = tonumber(self.onNumTxt1.text);
    self.priceNum = tonumber(self.onNumTxt2.text);
    --local 
end

function Lua_ExchangeJewelWindow:updateOnNum()

    if self.exchange_power < 1 then
        self.exchange_power = 1;
    end

    if DataCenter.moneyData.selectJewel == true then
        self.priceNum = math.floor(self.onNum/self.exchange_power);
    end
    
    if DataCenter.moneyData.selectGold == true then
        self.onNum = self.priceNum*self.exchange_power;
    end

    if self.onNum >= DataCenter.moneyData.max_exchange_jewel then
        self.onNum = DataCenter.moneyData.max_exchange_jewel
    end

    if self.priceNum >= DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) then
        self.priceNum = DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD);
    end

    if self.onNum <= self.exchange_power then
        self.onNum = self.exchange_power;
    end

    if self.priceNum <= 0 then
        self.priceNum = 1;
    end

    self.onNumTxt1.text = tostring(self.onNum);
    self.onNumTxt2.text = tostring(self.priceNum);
end

-- 钻石减
function Lua_ExchangeJewelWindow:onSubBtnClick(go)
    DataCenter.moneyData.selectJewel = true;
    DataCenter.moneyData.selectGold = false;
    self.onNum = tonumber(self.onNumTxt1.text);
    self.onNum = self.onNum - 1;
    self:updateOnNum();
end

-- 钻石加
function Lua_ExchangeJewelWindow:onAddBtnClick(go)
    DataCenter.moneyData.selectJewel = true;
    DataCenter.moneyData.selectGold = false;
    self.onNum = tonumber(self.onNumTxt1.text);
    self.onNum = self.onNum + 1;
    self:updateOnNum();
end

-- 钻石+10
function Lua_ExchangeJewelWindow:onAddTenBtnClick(go)
    DataCenter.moneyData.selectJewel = true;
    DataCenter.moneyData.selectGold = false;
    self.onNum = tonumber(self.onNumTxt1.text);
    self.onNum = self.onNum + 10;
    self:updateOnNum();
end

-- 钻石文本变化
function Lua_ExchangeJewelWindow:onNumTxtChange(text, charIndex, addedChar)
    local list = {};
    list.pox = 202;
    list.poy = 52;
    list.callBackOwner = self;
    list.callBack = self.onNumTxtInputCallBack;
    Lua_WindowUtil.openWin("Lua_CountInputWindow", WinParam.ACTION_AUTO, list)
    self.startNum = true;
end

function Lua_ExchangeJewelWindow:onNumTxtInputCallBack(data)
    if data == nil then
        return;
    end
    DataCenter.moneyData.selectJewel = true;
    DataCenter.moneyData.selectGold = false;
    if self.exchange_power < 1 then
        self.exchange_power = 1;
    end

    if data.state == 0 then -- 重置
        self.startNum = true;
        self.onNum = self.exchange_power;
        self.priceNum = 1;
        self:updateOnNum();
    elseif data.state == 1 then -- 数字
        if self.startNum ~= nil and self.startNum == true then
            self.onNum = data.num;
            self.startNum = false;
        else
            local str;
            if self.onNum > 0 then
                str = self.onNum..data.num;
            else
                str = tostring(data.num);
            end
            
            local len = string.len(str);
            local maxLen = string.len(self.max_sell_num);
            if len > maxLen then
                str = string.sub(str, len - maxLen + 1, len);
            end 
            self.onNum = tonumber(str);
        end
        self.priceNum = math.floor(self.onNum/self.exchange_power)

        self.onNumTxt1.text = tostring(self.onNum);
        self.onNumTxt2.text = tostring(self.priceNum);
    elseif data.state == 2 then -- ok
        self:updateOnNum();
    end
end

-- 元宝减
function Lua_ExchangeJewelWindow:onGoldSubBtnClick(go)
    DataCenter.moneyData.selectJewel = false;
    DataCenter.moneyData.selectGold = true;
    self.priceNum = tonumber(self.onNumTxt2.text);
    self.priceNum = self.priceNum - 1;
    self:updateOnNum();
end

-- 元宝加
function Lua_ExchangeJewelWindow:onGoldAddBtnClick(go)
    DataCenter.moneyData.selectJewel = false;
    DataCenter.moneyData.selectGold = true;
    self.priceNum = tonumber(self.onNumTxt2.text);
    self.priceNum = self.priceNum + 1;
    self:updateOnNum();
end

-- 元宝+10
function Lua_ExchangeJewelWindow:onGoldAddTenBtnClick(go)
    DataCenter.moneyData.selectJewel = false;
    DataCenter.moneyData.selectGold = true;
    self.priceNum = tonumber(self.onNumTxt2.text);
    self.priceNum = self.priceNum + 10;
    self:updateOnNum();
end

-- 元宝文本变化
function Lua_ExchangeJewelWindow:goldTxtChange(text, charIndex, addedChar)
    local list = { };
    list.pox = 202;
    list.poy = -5;
    list.callBackOwner = self;
    list.callBack = self.onGoldTxtInputCallBack;
    Lua_WindowUtil.openWin("Lua_CountInputWindow", WinParam.ACTION_AUTO, list)
    self.startPrice = true;
end

function Lua_ExchangeJewelWindow:onGoldTxtInputCallBack(data)
    if data == nil then
        return;
    end
    DataCenter.moneyData.selectJewel = false;
    DataCenter.moneyData.selectGold = true;

    if data.state == 0 then -- 重置
        self.startPrice = true;
        self.priceNum = 1;
        self.onNum =self.priceNum*self.exchange_power;
        self:updateOnNum();
    elseif data.state == 1 then -- 数字
        if self.startPrice ~= nil and self.startPrice == true then
            self.priceNum = data.num;
            self.startPrice = false;
        else
            local str;
            if self.priceNum > 0 then
                str = self.priceNum..data.num;
            else
                str = tostring(data.num);
            end

            local len = string.len(str);
            local maxLen = string.len(self.max_sell_num);
            if len > maxLen then
                str = string.sub(str, len - maxLen + 1, len);
            end 

            self.priceNum = tonumber(str);
        end
        self.onNum =self.priceNum*self.exchange_power;

        self.onNumTxt1.text = tostring(self.onNum);
        self.onNumTxt2.text = tostring(self.priceNum);
    elseif data.state == 2 then -- OK
        self:updateOnNum();
    end
end

function Lua_ExchangeJewelWindow:onOnShelvesBtnClick()
    local cmd = ProtoPublic_pb.Proto11400154();
    cmd.diamond_num = tonumber(self.onNum);
    sendMsg(11400154, cmd);
end

function Lua_ExchangeJewelWindow:dispose()
    self:superCall("dispose");
    DataCenter.moneyData.selectJewel = nil;
    DataCenter.moneyData.selectGold = nil;
end