Lua_GoToGainWindow = class("Lua_GoToGainWindow", Lua_ThirdSizeWindow);

function Lua_GoToGainWindow:ctor()
    self:superCall("ctor");

    self.w = 609;
    self.h = 400;
    self.isClickClose = true;

    self.windowName = "Lua_GoToGainWindow";
    self.skinName = "GotoGainWindow_skin";
end

function Lua_GoToGainWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.gotoBtn:addClickFuntion(self, self.onGotoClick);

    if self.itemImg == nil then
        self.itemImg = Lua_ToolImage.new(self.content);
        self.itemImg:setDepth(5);
        self.itemImg:setLocation(-2, 15, 0);
    end
end

function Lua_GoToGainWindow:showWin(param)
    self.data = param;

    self.titleNameText.text = param.titleName == nil and self.titleNameText.text or param.titleName;
    self.itemImg.data = param.imgData == nil and nil or param.imgData;
    self.itemImg:showNumLimit(param.totalNumber, param.needNumber,2)
    self.desLbl.text = LanUtil.formateStr(param.des, self.itemImg.data.colorName);
    if self.data ~= nil and self.data.winName ~= nil then
        self.gotoBtn.label = param.gotoName == nil and self.gotoBtn.txt.text or param.gotoName;
    else
        self.gotoBtn.label = LanUtil.getValue(121214);
    end
end

function Lua_GoToGainWindow:onGotoClick(go)
    self:Goto();
    self:hide();
end

function Lua_GoToGainWindow:onBtnCloseClick(go)
    self:Close();
    self:hide();
end

function Lua_GoToGainWindow:Goto()
    if self.data ~= nil and self.data.gotoFun ~= nil then
        self.data.gotoFun(self.data.owner, self.data);
    else
        if self.data ~= nil and self.data.winName ~= nil then
            Lua_WindowUtil.openWin(self.data.winName, WinParam.ACTION_OPEN, self.data.data);
        end
    end
end

function Lua_GoToGainWindow:Close()
    if self.data ~= nil and self.data.cancelFun ~= nil then
        self.data.cancelFun(self.data.owner, self.data);
    end
end

function Lua_GoToGainWindow:dispose()
    self:superCall("dispose");
end
