checkRequire("Lua_NumberInputItem");
Lua_NumberInputWindow = class("Lua_NumberInputWindow", Lua_ThirdSizeWindow);
function Lua_NumberInputWindow:ctor()
	self:superCall("ctor", true, 3500, true, "");

	self.windowName = "Lua_NumberInputWindow";
	self.skinName = "NumberInputWindow_skin";
	self.w = 600;
	self.h = 371;
	self.isClickClose = false;
end

function Lua_NumberInputWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.item = Lua_ToolImage.new(self.content);
	self.item:setDepth(5);
	self.item:setLocation(0, 74, 0);

	self.numItem = Lua_NumberInputItem.new(self.content);
	self.numItem:setDepth(5);
	self.numItem:setWindowOffset(0, 105);
	self.numItem:setLocation(-44, -28, 0);

	self.subBtn:addClickFuntion(self, self.onSubClick);
	self.cancelBtn:addClickFuntion(self, self.hide);
end

function Lua_NumberInputWindow:showWin(param)
	self.owner = param.owner;
	self.callBack = param.callBack;

	self.startMax = param.startMax;
	self.numItem:setMinMaxValue(param.minNum == nil and 1 or param.minNum, param.maxNum);
	if self.startMax == true then
		self.numItem:setNum(param.maxNum);
	else
		self.numItem:setNum(1);
	end

	self.callBackData = param.callBackData;
	if self.callBackData ~= nil then
		self.item.data = self.callBackData;
		self.itemName.text = self.callBackData.colorName;
	else
		self.item.data = nil;
		self.itemName.text = "";
	end

	if self.titleNameText ~= nil then
		if param.titleName == nil then
			self.titleNameText.text = "";
		else
			self.titleNameText.text = param.titleName;
		end
	end
end

function Lua_NumberInputWindow:onSubClick(go)
	if self.callBack ~= nil then
		if self.owner ~= nil then
			self.callBack(self.owner, self.numItem.num, self.callBackData);
		else
			self.callBack(self.numItem.num, self.callBackData);
		end
	end
	self:hide();
end

function Lua_NumberInputWindow:dispose()
	if self.item ~= nil then
		self.item:dispose();
		self.item = nil;
	end
	if self.numItem ~= nil then
		self.numItem:dispose();
		self.numItem = nil;
	end
	self.owner = nil;
	self.callBack = nil;

	self:superCall("dispose");
end