-- 改名卡
Lua_RenameTipWindow = class("Lua_RenameTipWindow", Lua_ThirdSizeWindow);
function Lua_RenameTipWindow:ctor()
    self:superCall("ctor", true, nil, true, LanUtil.getValue(128004));

    self.w = 600;
    self.h = 365;

    self.windowName = "Lua_RenameTipWindow";
    self.skinName = "RenameTipWindow_skin";
end

function Lua_RenameTipWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.nameMaxLen = 12;

	self.defaultMsg = LanUtil.getValue(128000);
	self.nameInput.defaultText = self.defaultMsg;
	self.nameInput.text = ""; 
    self.nameInput.characterLimit = self.nameMaxLen;
    self.nameInput.maxLineCount = 1;

    self.renameBtn:addClickFuntion(self, self.onRenameBtnClick);
end

function Lua_RenameTipWindow:showWin(param)
    self.param = param;
end

function Lua_RenameTipWindow:onRenameBtnClick()
    if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
        OperateAlert.show(LanUtil.getValue(121419));
        return;
    end
    self.clickTime = getTime();

    local newName = self.nameInput.text;
    if newName == nil or newName == "" or newName == self.defaultMsg then
        OperateAlert.show(LanUtil.getValue(128001));
        return;
    end

    -- if LanUtil.getStrLen(newName) > self.nameMaxLen then
    --     OperateAlert.show(LanUtil.getValue(128002));
    --     return;
    -- end
    if getCVersion() >= 1290 then
        if LanUtil.isIncludeInvalidName(newName) == true then
            OperateAlert.show(LanUtil.getValue(128003));
            return;
        end
    else
        if LanUtil.isIncludeInvalidWord(newName) == true then
            OperateAlert.show(LanUtil.getValue(128003));
            return;
        end
    end

    if self.param.subType == Lua_PackTypeDefine.ROLE_RENAME_TYPE then
        local cmd = ProtoPublic_pb.Proto11400120();
        cmd.index = self.param.index;
        cmd.name = newName;
        sendMsg(11400120, cmd);
    elseif self.param.subType == Lua_PackTypeDefine.FACTION_RENAME_TYPE then
        local cmd = ProtoPublic_pb.Proto11400121();
        cmd.index = self.param.index;
        cmd.name = newName;
        sendMsg(11400121, cmd);
    end
end

function Lua_RenameTipWindow:dispose()
    self:superCall("dispose");
end