Lua_RuleTipWindow = class("Lua_RuleTipWindow", Lua_Window);
function Lua_RuleTipWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_RuleTipWindow";
	self.skinName = "RuleTipWindow_skin";
	self.layer = 4500;
	self.isClickClose = true;
end

function Lua_RuleTipWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, 0, 530, 220));
	self.dragContainer:setLocation(0, 25, 0);
	self.draggableInfoPanel = Lua_InfoPanel.new(self.dragContainer);

	self.subBtn:addClickFuntion(self, self.onBtnCloseClick);
end

function Lua_RuleTipWindow:showWin(param)
	self.draggableInfoPanel:setText(param);
end

function Lua_RuleTipWindow:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	if self.draggableInfoPanel ~= nil then
		self.draggableInfoPanel:dispose();
		self.draggableInfoPanel = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_InfoPanel = class("Lua_InfoPanel", Lua_DragContainerItem);
function Lua_InfoPanel:ctor(dragContainer)
	self:superCall("ctor", dragContainer.sub);

	dragContainer:addSubContainer(self, true);
	self.dragContainer = dragContainer;
end

function Lua_InfoPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.label = UICreate.createLabel(self.content, "", -265, 110, 530, 0, 22);
	self.label.spacingY = 8;
	self.label.pivot = UIWidget.Pivot.TopLeft;
	self.label.overflowMethod = UILabel.Overflow.ResizeHeight;
end

function Lua_InfoPanel:setText(data)
	self.label.text = "[85A8BE]" .. data .. "[-]";

	self.dragContainer:updateChildPos();
	self.dragContainer.canDrag = self:getHeight() > 220;
end

function Lua_InfoPanel:getHeight()
	return self.label.height;
end

function Lua_InfoPanel:dispose()
	if self.label ~= nil then
		self.label:dispose();
		self.label = nil;
	end

	self:superCall("dispose");
end