﻿-- 使用方式
-- if DataCenter.neverTip:getNeverValue(Lua_NeverTipData.RELIVE) == true then
-- 	self:onSureCallBackFun();
-- else
-- 	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {
-- 		owner = self,
-- 		neverTip = Lua_NeverTipData.RELIVE,
-- 		des = "",
-- 		type = 1,
-- 		countDown = 10,
-- 		subFun = self.onSureCallBackFun,
-- 		cancelFun = self.onCancelCallBackFun
-- 	});
-- end

Lua_TipsWindow = class("Lua_TipsWindow", Lua_Window);
function Lua_TipsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TipsWindow";
	self.skinName = "TipsWindow_skin";
	self.needClose = true;
	self.isClickClose = true;
end

function Lua_TipsWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.subBtn:addClickFuntion(self, self.onSubClick);
	self.cancelBtn:addClickFuntion(self, self.onCancelClick);
end

function Lua_TipsWindow:onSubClick(go)
	if self.needClose == true then
		self:hide();
		self:exeSub();
	else
		self:exeSub();
	end
end

function Lua_TipsWindow:onCancelClick(go)
	self.needClose = false;
	self:exeCancel();

	if self.needClose == true then
		return;
	end
	self:hide();
end

function Lua_TipsWindow:exeSub()
	if self.data.neverTip ~= nil then
		DataCenter.neverTip:setNeverValue(self.data.neverTip, self.tipBox.seleted);
	end

	if self.data ~= nil and self.data.subFun ~= nil then
		self.data.subFun(self.data.owner, self.data);
	end
end

function Lua_TipsWindow:exeCancel()
	if self.data.neverTip ~= nil then
		DataCenter.neverTip:setNeverValue(self.data.neverTip, self.tipBox.seleted);
	end

	if self.data ~= nil and self.data.cancelFun ~= nil then
		self.data.cancelFun(self.data.owner, self.data);
	end
end

function Lua_TipsWindow:onBtnCloseClick(go)
	if self.data ~= nil and self.data.excuteCancelCBInCloseClick == false then
		self:hide();
	else
		-- self:exeCancel();
		self:hide();
	end
end

function Lua_TipsWindow:showWin(param)
	self.needClose = true;
	self.data = param;
	
	if param.isShowCloseBtn == false then
		self.btnClose:setEnable(false);
	end

	self.infoTxt.text = param.des;
	if param.txtFontSize ~= nil then
		self.infoTxt.fontSize = param.txtFontSize;
	end

	if param.txtSpacingX ~= nil then
		self.infoTxt.spacingX = param.txtSpacingX;
	end

	if param.txtSpacingY ~= nil then
		self.infoTxt.spacingY = param.txtSpacingY;
	end

	if param.txtSize ~= nil then
		self.infoTxt:SetDimensions(param.txtSize.x, param.txtSize.y);
	end

	if param.isSecret ~= nil and param.isSecret == true then -- 生肖秘藏
		local fenge = UICreate.createUIAtlasImage(self.content, "iconantlas1", "fengexian", 1.5, 4, 0, 0)
		fenge:setDepth(3);
		self.tipBox:setLocation(-75, -35, 0);
	end

	if self.data.neverTip ~= nil then
		self.tipBox:setEnable(true);
		self.tipBox.seleted = false;
	else
		self.tipBox:setEnable(false);
	end

	if param.type == 1 then
		self.subBtn.label = param.subName == nil and LanUtil.getValue(105029) or param.subName;
		self.cancelBtn.label = param.cancelName == nil and LanUtil.getValue(10016) or param.cancelName;
		self.titleNameTxt.text = param.titleName == nil and self.titleNameTxt.text or param.titleName;
		self.tipsTxt.text = param.showHint == nil and "" or param.showHint;
	elseif param.type == 2 then
		self.subBtn.label = param.subName == nil and LanUtil.getValue(105029) or param.subName;
		self.subBtn:setLocation(0, -103, 0);
		self.titleNameTxt.text = param.titleName == nil and self.titleNameTxt.text or param.titleName;--新增 2022/6/10，针对VIP过期提示，其他界面未验证，如果其他界面出问题了看这里
		self.cancelBtn:setEnable(false);
	else
		self.subBtn:setEnable(false);
		self.cancelBtn:setEnable(false);
	end

	-- 用于自动关闭Tips界面;
	self.countDownDefault = param.countDownDefault == nil and nil or param.countDownDefault;
	if self.data.countDown ~= nil then
		self.startTime = getTime();
		Lua_CommonUtil.addTimer("tipCount", 0.1, self, self.onCountDown);
		self:onCountDown();
	else
		Lua_CommonUtil.removeTimer(self, self.onCountDown);
	end

	self:showRewards(param.rewardArr, param.txtPivot);
	
	if param.showChaiJie ~= nil and param.showChaiJie == true then
		self:onShowChaiJieEquip()
	end
end

function Lua_TipsWindow:showRewards(arr, myPivot)
	if arr == nil or arr:getSize() <= 0 then
		if myPivot == nil then
			self.infoTxt:setLocation(0, 78);
			self.infoTxt.pivot = UIWidget.Pivot.Center;
		else
			self.infoTxt:setLocation(-236, 78);
			self.infoTxt.pivot = myPivot;
			
			self.tipsTxt:setLocation(0, -28);
		end

		if self.data.isSecret == true then
			self.infoTxt:setLocation(0, 75, 0);
		end

		if self.data.txtPos ~= nil then
			self.infoTxt:setLocation(self.data.txtPos.x, self.data.txtPos.y);
		end

		if self.rewardsTxt ~= nil then
			self.rewardsTxt.text = "";
		end

		if self.rewardList ~= nil then
			self.rewardList:dispose();
			self.rewardList = nil;
		end
	else
		self.infoTxt.pivot = UIWidget.Pivot.Top;
		self.infoTxt:setLocation(-2, 120);

		if self.rewardsTxt == nil then
			self.rewardsTxt = UICreate.createLabel(self.content, LanUtil.getValue(123805), -247, 45, 300, 30, 22);
			self.rewardsTxt:setDepth(4)
		else
			self.rewardsTxt.text = LanUtil.getValue(123805);
		end

		if self.rewardList == nil then
			self.rewardList = Lua_DragList.new(self.content, 2, Vector4(48, -86, 420, 72));
			self.rewardList:setLocation(-50, 70, 0);
			self.rewardList:setListCell(Lua_RewardItemTips, 80, 75, self.data.rewardArr:getSize());
			self.rewardList.canDrag = true;
		end
		self.rewardList:setLuaArrayData(self.data.rewardArr, false);
	end
end

function Lua_TipsWindow:onShowChaiJieEquip()
	self.infoTxt.pivot = UIWidget.Pivot.Center;
	self.infoTxt:setLocation(-5, 80);

	local item;
	local id = Lua_CommonUtil.getCommonConfig("chaijie_equip", 1);
	local order = self.data.equipData.order;
	local num = Lua_CommonUtil.getCommonConfig("chaijie_equip", 3)[order];
	for i = 1, 4 do
		item = Lua_ToolImage.new(self.content);
		item:setDepth(5);
		item:setLocation(-170 + (i - 1) * 100, -15, 0);

		if i == 1 then
			item.data = Lua_ToolVo.new(id, num);
		else
			item.data = nil;
			item:showItemBgByName("ui_common_prop_6");
			item:setDefaultIcon("forgingWindow", "suiji_equip");
			item:showDefaultIcon(true);
		end
	end
end

function Lua_TipsWindow:onCountDown()
	local leftTime = math.floor(self.data.countDown -(getTime() - self.startTime));
	if leftTime <= 0 then
		if self.countDownDefault == 2 then
			self:exeCancel()
		else
			self:exeSub();
		end
		self:hide();
	else
		local desc;
		if self.countDownDefault == 2 then
			desc = self.data.cancelName == nil and LanUtil.getValue(10016) or self.data.cancelName;
			self.cancelBtn.label = desc .. "(" .. leftTime .. ")";
		else
			desc = self.data.subName == nil and LanUtil.getValue(105029) or self.data.subName;
			self.subBtn.label = desc .. "(" .. leftTime .. ")";
		end
	end
end

function Lua_TipsWindow:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onCountDown);

	self:superCall("dispose");
end





--------------------------------------------------





Lua_RewardItemTips = class("Lua_RewardItemTips", Lua_ListCell);
function Lua_RewardItemTips:ctor(p)
	self:superCall("ctor", p);
end

function Lua_RewardItemTips:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(0, 3, 0);
	self.itemImg:setScale(0.8, 0.8, 0.8);
	self.itemImg:setCanClick(false);
end

function Lua_RewardItemTips:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.itemImg.data = data;
end

function Lua_RewardItemTips:onPlayerSoundClick()
	Lua_PackUtil.showItemInfo(self.data, false);
end

function Lua_RewardItemTips:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self.data = nil;

    self:superCall("dispose");
end